/*
 * Copyright (C) 2006 - 2022 Lekab Communication Systems AB
 */
package com.example.demo;

import jakarta.persistence.EntityManager;

/**
 * @author Andreas Asplund <a href="mailto:andreas.asplund@lekab.com">andreas.asplund@lekab.com</a>
 */
public class AnimalRepositoryImpl implements AnimalRepositoryCustom {
    private final EntityManager entityManager;

    public AnimalRepositoryImpl(EntityManager entityManager) {
        this.entityManager = entityManager;
    }

    @Override
    public Long countWithJpa(Class<? extends Animal> animal) {
        var query = entityManager.createQuery("select count(animal) from Animal animal where type(animal) = ?1", Long.class);
        query.setParameter(1, Dog.class);
        return query.getSingleResult();
    }
}
